with Common_Units;
package ADC is
-- Specification of a make-believe analog to digital converter

   type    Channel_Number is range 0 .. 31;
   subtype Input_Volts    is Common_Units.Volts range 0.0 .. 5.0;
   type    Gain_Choice    is (One, Two, Four);

   Over_Range : exception;

   procedure Read (Channel : in  Channel_Number;
                   Gain    : in  Gain_Choice;
                   Value   : out Input_Volts);
   -- Returns the voltage on the given channel
   -- Potentially blocking (executes a delay statement)
   -- Raises Over_Range if the amplified voltage exceeds 5 volts

private
   for Channel_Number'Size use 5;
   for Gain_Choice use (One => 2#001#, Two => 2#010#,
                        Four => 2#100#);
   for Gain_Choice'Size use 3;
end ADC;