with Bounded_Queue;
with Ada.Text_IO;   use Ada.Text_IO;
procedure Bounded_Queue_Example is

   package Int_Queue is new Bounded_Queue
                            (Element_Type => Integer);
   use Int_Queue;

   My_Queue : Int_Queue.Queue_Type (Max_Size => 100);
   Value    : Integer;

begin
   for Count in 17 .. 52 loop
      Enqueue (Queue => My_Queue, Item => Count);
   end loop;
   Dequeue (Queue => My_Queue, Item => Value);
   Put_Line (Integer'Image (Value));
   Clear (My_Queue);
   Dequeue (Queue => My_Queue, Item => Value);
   Put_Line (Integer'Image (Value));
exception
   when Underflow | Overflow =>
      Put_Line ("An exception was raised");
end Bounded_Queue_Example;