with Ada.Text_IO;          use Ada.Text_IO;
with Ada.Integer_Text_IO;  use Ada.Integer_Text_IO;
with Ada.Float_Text_IO;    use Ada.Float_Text_IO;
with ADC;
with DAC;
procedure Control_Structures is

   A : Integer  := 1;
   B : Integer  := 2;
   C : Integer  := 3;
   Ch : Character := 'y';
   Temperature   : Integer;
   Valve_Setting : Integer;
   Sum           : Integer;
   Value         : Integer;
   X             : Float := 841.0;
   Approx        : Float;
   Tolerance     : constant Float := 0.00001;

   procedure Calculate_Valve (Current_Temp : in  Integer;
                              New_Setting  : out Integer) is
   begin
      New_Setting := 2 * Current_Temp;
   end Calculate_Valve;

begin

   A := 9;
   B := 2;
   for Count in A .. B loop          -- With a null range, this
      Put (Count);                   -- loop iterates zero times
      New_Line;
   end loop;
   for Count in reverse A .. B loop  -- With a null range, this
      Put (Count);                   -- loop iterates zero times
      New_Line;
   end loop;


   for Count in reverse 5 .. 8 loop
      Put (Count);
      New_Line;
   end loop;

   for Count in 5 .. 8 loop
      Put (Count);
      New_Line;
   end loop;

   Approx := X / 2.0;
   while abs (X - Approx ** 2) > Tolerance loop
      Approx := 0.5 * (Approx + X / Approx);
   end loop;
   Put ("The square root of ");
   Put (Item => X, Fore => 1, Aft => 5, Exp => 0);
   Put (" is approximately ");
   Put (Item => Approx, Fore => 1, Aft => 5, Exp => 0);
   New_Line;

   Sum := 0;
   loop
      Get (Value);
      exit when Value < 0;
      Sum := Sum + Value;
   end loop;


   loop
      ADC.Read (Temperature);          -- Read the temperature from the ADC
      Calculate_Valve (Current_Temp => Temperature,    -- Calculate the new
                       New_Setting  => Valve_Setting); -- gas valve setting
      DAC.Write (Valve_Setting);       -- Change the valve setting
      delay 1.5;                       -- Wait 1.5 seconds
   end loop;

   if A < 0 then
      Put_Line ("A is negative");
   end if;

   if A > B then
      Put_Line ("A is greater than B");
   else
      Put_Line ("A is not greater than B");
   end if;

   if A = B then
      Put_Line ("A and B are equal");
   elsif A > B then
      Put_Line ("A is greater than B");
   else
      Put_Line ("A is less than B");
   end if;

   if A > B and A > C then
      Put_Line ("A is greater than both B and C");
   elsif B > A and B > C then
      Put_Line ("B is greater than both A and C");
   elsif C > A and C > B then
      Put_Line ("C is greater than both A and B");
   end if;

   case Ch is
      when 'a' .. 'z' =>
         Put_Line ("Ch is a lowercase letter");
      when 'A' .. 'Z' =>
         Put_Line ("Ch is an uppercase letter");
      when '0' .. '9' =>
         Put_Line ("Ch is a digit");
      when '.' | '!' | '?' =>
         Put_Line ("Ch is a sentence termination character");
      when others =>
         Put_Line ("Ch is some other character");
   end case;

end Control_Structures;
   