with Ada.Integer_Text_IO;  use Ada.Integer_Text_IO;
with Ada.Text_IO;          use Ada.Text_IO;
with Ada.IO_Exceptions;
procedure Exceptions_Example is

   subtype Count_Range is Integer range 0 .. 10;

   procedure Get_Count (Prompt  : in  String;
                        Count   : out Count_Range) is
   begin
      loop  -- Data validation loop
         Put_Line (Prompt);
         begin
            Ada.Integer_Text_IO.Get (Count);
            exit;
         exception
            when Constraint_Error =>
               Put_Line ("Value must be between 0 and 10");
            when Ada.IO_Exceptions.Data_Error =>
               Put_Line ("Value must be a number");
               Ada.Text_IO.Skip_Line;
         end;
      end loop;
   exception
      when Ada.IO_Exceptions.End_Error =>
         Count := 0;
   end Get_Count;

   My_Count : Count_Range;
begin
   Get_Count (Prompt => "Please enter the count",
              Count  => My_Count);
   Put (My_Count);
end Exceptions_Example;