with Ada.Text_IO;  use Ada.Text_IO;
procedure Palindrome is

   function Is_Palindrome (Item : in String) return Boolean is
   begin
      if Item'Length <= 1 then
         -- All strings of length 0 and 1 are palindromes
         return True;
      elsif Item (Item'First) /= Item (Item'Last) then
         -- The first and last letter of the string are different
         return False;
      else
         -- First and last characters match, check the remaining
         return Is_Palindrome (Item (Item'First + 1 .. Item'Last - 1));
      end if;
   end Is_Palindrome;

   Max_Length : constant Positive := 100;
   subtype Line_Type is String (1 .. Max_Length);

   Line  : Line_Type;  -- Characters entered by user
   Count : Natural;    -- Number of characters entered

begin
   Put_Line ("Enter a line.  I'll tell you if it is a palindrome.");
   -- Get_Line reads characters to end of line
   -- Last is the index of the last character read
   Get_Line (Item => Line,  Last => Count);
   -- Slice off garbage before calling Is_Palindrome
   if Is_Palindrome (Line (1 .. Count)) then
      Put_Line ("is a palindrome");
   else
      Put_Line ("is not a palindrome");
   end if;
end Palindrome;
