with Interfaces;
package Port_IO  is

-- This package provides access to I/O ports. It provides the
-- Ada programmer with the Intel x86 IN and OUT instructions.

   -- Port addresses
   type Address_Range is new Interfaces.Unsigned_16;

   -- Data for IN and OUT instructions
   type Byte is new Interfaces.Unsigned_8;
   type Word is new Interfaces.Unsigned_16;

   -- The following procedures write a byte or word to a port
   procedure Out_Byte (Address : in Address_Range;
                       Data    : in Byte);
   procedure Out_Word (Address : in Address_Range;
                       Data    : in Word);

   -- The following functions read a byte or word from a port
   function In_Byte (Address : in Address_Range) return Byte;
   function In_Word (Address : in Address_Range) return Word;
end Port_IO;
