with Ada.Text_IO;  use Ada.Text_IO;
procedure Record_Examples is

   subtype Part_ID is Integer range 1000 .. 9999;
   type    Dollars is delta 0.01 digits 7 range 0.0 .. 10_000.0;

   type Part_Rec is
      record
         ID       : Part_ID;
         Price    : Dollars;
         Quantity : Natural;
      end record;

   Part     : Part_Rec;
   Discount : Dollars;

   type Part_Array is array (Positive range <>) of Part_Rec;

   type Inventory_List (Max_Size : Positive) is
      record
         Size : Natural := 0;
         Items : Part_Array (1..Max_Size);  -- Max_Size used in index constraint
      end record;

   Inventory : Inventory_List (Max_Size => 1000);


begin
   Part.ID       := 1234;
   Part.Price    := 1_856.25;
   Part.Quantity := 597;
   Discount      := 0.15 * Part.Price;

   -- Append a new part to the inventory list
   if Inventory.Size = Inventory.Max_Size then
      Put_Line ("The inventory list is full");
   else
      Inventory.Size := Inventory.Size + 1;
      Inventory.Items (Inventory.Size).ID       := 4567;
      Inventory.Items (Inventory.Size).Price    := 2.37;
      Inventory.Items (Inventory.Size).Quantity := 0;
   end if;


end Record_Examples;