with Ada.Text_IO;
procedure Subtype_Examples is
   subtype Lowercase is Character range 'a' ..'z';
   subtype Negative  is Integer   range Integer'First .. -1;

   type Day_Type   is (Monday, Tuesday, Wednesday, Thursday,
                       Friday, Saturday, Sunday);
   subtype Weekday is Day_Type range Monday .. Friday;
   subtype Weekend is Day_Type range Saturday .. Sunday;

   type    Pounds       is digits 6 range 0.0 .. 1.0E+06;
   subtype UPS_Weight   is Pounds   range 1.0 .. 100.0;
   subtype FedEx_Weight is Pounds   range 0.1 .. 1.0;

   Total    : Pounds;
   Box      : UPS_Weight;
   Envelope : FedEx_Weight;

subtype Column_Number is Ada.Text_IO.Count;  -- A synonym

begin
   Total := Box + Envelope;  -- Adding two different subtypes with same base type
end Subtype_Examples;