with Ada.Text_IO;
procedure Type_Examples is

type String is array(Positive range <>) of Character;  -- Definition from Ada.Standard

   type Thirds is delta 1.0 / 3.0  range 0.0 .. 100_000.0;
   type Volts  is delta 2.0**(-12) range 0.0 .. 5.0;
   type Dollars is delta 0.01 digits 12;

   package Thirds_IO is new Ada.Text_IO.Fixed_IO (Thirds);
   package Volts_IO  is new Ada.Text_IO.Fixed_IO (Volts);
   package Dollar_IO is new Ada.Text_IO.Decimal_IO (Dollars);

   type Pome      is range   0 .. 120;
   type Citrus    is range -17 .. 30;
   type Big_Range is range -20 .. 1_000_000_000_000_000_000;

   package Pome_IO   is new Ada.Text_IO.Integer_IO (Pome);
   package Citrus_IO is new Ada.Text_IO.Integer_IO (Citrus);
   package Big_IO    is new Ada.Text_IO.Integer_IO (Big_Range);

   Apples  : Pome;
   Oranges : Citrus;
   Fruit   : Big_Range;

   type Digit  is mod 10;    -- range is from 0 to 9
   type Byte   is mod 256;   -- range is from 0 to 255
   type Nybble is mod 16;    -- range is from 0 to 15
   type Word   is mod 2**32;	-- range is from 0 to 4,294,967,295

   package Digit_IO  is new Ada.Text_IO.Modular_IO (Digit);
   package Byte_IO   is new Ada.Text_IO.Modular_IO (Byte);
   package Nybble_IO is new Ada.Text_IO.Modular_IO (Nybble);
   package Word_IO   is new Ada.Text_IO.Modular_IO (Word);

   Value : Nybble;
begin
--   for Letter in 'a' .. 'z' loop -- The type of the character literals is ambiguous
   for Letter in Character range 'a' .. 'z' loop
      Ada.Text_IO.Put (Letter);
   end loop;
   Fruit := Big_Range (Apples) + Big_Range (Oranges);

   Value := 12 + 8;    -- Value is assigned 4
end Type_Examples;