with Ada.Text_IO;              use Ada.Text_IO;
with Ada.Task_Identification;
procedure Task_ID_Demo is

   type Color_Type is (Red, Green, Yellow, Blue);

   procedure Turn_On_LED (Color : in Color_Type) is
   begin
      Put_Line (Color_Type'Image (Color) & " on");
   end Turn_On_LED;

   procedure Turn_Off_LED (Color : in Color_Type)is
   begin
      Put_Line (Color_Type'Image (Color) & " off");
   end Turn_Off_LED;

   ----------------------------------------------------------------
   task Flash_Red_LED;

   task body Flash_Red_LED is
   begin
      loop
         Turn_On_LED (Red);
         delay 0.5;
         Turn_Off_LED (Red);
         delay 0.5;
      end loop;
   end Flash_Red_LED;
   ----------------------------------------------------------------
   task type Flash_LED (Color  : Color_Type;
                        Period : Natural);
   task body Flash_LED is
      use Ada.Task_Identification;
      My_ID : Task_Id;
   begin
      My_ID := Current_Task;
      Put_Line (Color_Type'Image (Color) &
                "'S ID is " & Image (My_ID));
      loop
         Turn_On_LED (Color);
         delay Duration (Period) / 2;
         Turn_Off_LED (Color);
         delay Duration (Period) / 2;
      end loop;
   end Flash_LED;
   ----------------------------------------------------------------
   -- Two task objects (variables)
   Yellow_LED : Flash_LED (Color  => Yellow,
                           Period => 4);
   Green_LED  : Flash_LED (Color  => Green,
                           Period => 3);
   -- A pointer to a task object
   type Flash_Ptr is access Flash_LED;
   Blue_LED   : Flash_Ptr;

begin
   Put_Line ("Flashing LEDs");
   Blue_LED := new Flash_LED (Color  => Blue,
                              Period => 8);
end Task_ID_Demo;