procedure Atomic_Demo is

   Value : Natural := 0;
   pragma Atomic (Value);

   task type Writer;
   task body Writer is
      My_Value : Natural := 0;
   begin
      loop
         -- Create My_Value
         -- My_Value := ...
         --Write My_Value to the shared global
         Value := My_Value;
         delay 0.1;
      end loop;
   end Writer;

   task type Reader;
   task body Reader is
      My_Value : Natural;
   begin
      loop
         -- Read the shared global
         My_Value := Value;
         -- Do something with My_Value
         -- ...
         delay 0.2;
      end loop;
   end Reader;

   type Writer_Array is array (1 .. 2) of Writer;
   type Reader_Array is array (1 .. 8) of Reader;

   The_Writers : Writer_Array;
   The_Readers : Reader_Array;

begin
   Value := 25;
end Atomic_Demo;

         