with Ada.Text_IO;          use Ada.Text_IO;
with Ada.Integer_Text_IO;  use Ada.Integer_Text_IO;
with Barriers;             use Barriers;
procedure Barrier_Demo is

-- This program demonstrates the barrier.
-- It creates horse tasks dynamically without
-- deallocating completed task memory.


   Starting_Gate : Barrier (Group_Size => 5);

   task type Horse (My_ID : Positive);
   task body Horse is
   begin
      Starting_Gate.Wait;
      Put (My_ID);
      New_Line;
   end Horse;

   type Horse_Ptr is access Horse;

   Racer : Horse_Ptr;
   ID    : Positive   := 1;

begin
   -- Each iteration of this loop brings two horese to the starting gate
   -- As soon as five horses have arrived, the gate is opened.  The sixth
   -- horse to arrive must wait for the next race, even if the first five
   -- are still leaving the startng gate.
   loop
      Put_Line ("Press enter to bring two horses to the starting gate");
      Skip_Line;
      Racer := new Horse (ID);
      ID := ID + 1;
      Racer := new Horse (ID);
      ID := ID + 1;
   end loop;

end Barrier_Demo;

   