with Ada.Text_IO;
package body Protected_Output is

   protected type Semaphore (Initial_Value : Natural) is
      procedure Signal;
      entry Wait;
   private
      Count : Natural := Initial_Value;
   end Semaphore;

   protected body Semaphore is
      procedure Signal is
      begin
         Count := Count + 1;
      end Signal;

      entry Wait when Count > 0 is
      begin
         Count := Count - 1;
      end Wait;
   end Semaphore;

   My_Semaphore : Semaphore (Initial_Value => 1);

   -----------------------------------------------------
   procedure Put (Item : in String) is
   begin
      My_Semaphore.Wait;
      Ada.Text_IO.Put (Item);
      My_Semaphore.Signal;
   end Put;

   procedure Put_Line (Item : in String) is
   begin
      My_Semaphore.Wait;
      Ada.Text_IO.Put_Line (Item);
      My_Semaphore.Signal;
   end Put_Line;

end Protected_Output;
