package body Resource_Allocation is

   protected body Manager is

      entry Take (Number_Required : in Positive)
                  when Inventory > 0 is
      begin
         if Number_Required <= Inventory then
            Inventory := Inventory - Number_Required;
         else
            requeue Wait;
         end if;
      end Take;

      procedure Replace (Number_Returned : in Positive) is
      begin
         Inventory := Inventory + Number_Returned;
         Tasks_Waiting := Wait'Count;
         if Tasks_Waiting > 0 then
            Resource_Released := True;
         end if;
      end Replace;

      entry Wait (Number_Required : in Positive)
            when Resource_Released is
      begin
         -- Decrement number of tasks waiting
         Tasks_Waiting := Tasks_Waiting - 1;
         -- Am I the last task to be checked?
         if Tasks_Waiting = 0 then
            -- Close the barrier
            Resource_Released := False;
         end if;
         -- Are there enough resources for my request
         if Number_Required <= Inventory then
            Inventory := Inventory - Number_Required;
         else  -- Get back in line and wait for more resources
            requeue Wait;
         end if;
      end Wait;

   end Manager;

end Resource_Allocation;
