package Resource_Allocation is

   protected type Manager (Initial_Inventory : Positive) is
      entry Take (Number_Required : in Positive);
      -- Make a request for resources.  The caller is blocked
      -- until the amount requested is available
      procedure Replace (Number_Returned : in Positive);
      -- Return resources so some other task may use them.
   private
      Inventory         : Natural := Initial_Inventory;
      Tasks_Waiting     : Natural;
      Resource_Released : Boolean := False;
      entry Wait (Number_Required : in Positive);
   end Manager;

end Resource_Allocation;