package Turnstile is

-- This package provides an interface to the
-- Museum's turnstile sensors

   -- The Museum has four doors
   type Entrance_Type  is (North, South, East, West);
   -- A person can enter or leave through a turnstile
   type Direction_Type is (Enter, Leave);

   procedure Get (Entrance  : in  Entrance_Type;
                  Direction : out Direction_Type);
   -- The caller of this procedure is blocked until a
   -- person passes through the turnstile at the given
   -- entrance.  Its return value indicates whether the
   -- person has entered or left the Museum.

end Turnstile;
   