with Ada.Text_IO;       use Ada.Text_IO;
with Ada.Float_Text_IO; use Ada.Float_Text_IO;
procedure Else_Option is

   subtype Degrees is Float range 32.0 .. 85.0;


   procedure Get_Temperature (Item : out Degrees) is
   begin
      Item := (Degrees'First + Degrees'Last) / 2.0;
   end Get_Temperature;

   procedure Display_Temperature (Item : in Degrees) is
   begin
      Put (Item => Item, Fore => 3, Aft => 1, Exp => 0);
      New_Line;
   end Display_Temperature;



   task Monitor_Temperature is
      entry Change_Rate (Value : in Duration);
   end Monitor_Temperature;

   task body Monitor_Temperature is
      My_Delay : Duration := 5.0;
      Current  : Degrees;
   begin
      loop
         select
            accept Change_Rate (Value : in Duration) do
               My_Delay := Value;
            end Change_Rate;
         else
            null;
         end select;
         Get_Temperature (Current);
         Display_Temperature (Current);
         delay My_Delay;
      end loop;
   end Monitor_Temperature;

begin
   for Count in reverse 1 .. 5 loop
      Monitor_Temperature.Change_Rate (Duration (Count));
      delay 5.0;
   end loop;
end Else_Option;
         