with Lights;  -- Package with light control/status registers
package body Headlights_V1 is

   protected Control is
      procedure Signal_Event (Event : Event_Type);
      function Current_State return State_Type;
   private
      State : State_Type := Off;
   end Control;

   protected body Control is
      procedure Signal_Event (Event : Event_Type) is
      begin
         case State is
            when Off =>
               case Event is
                  when Switch_On =>
                     State := On;
                     Lights.Set_Headlights_On;
                  when Switch_Off | High_On | High_Off =>
                     null;
               end case;
            when On =>
               case Event is
                  when Switch_Off =>
                     State := Off;
                     Lights.Set_Headlights_Off;
                  when High_On =>
                     State := High;
                     Lights.Set_High_Beams_On;
                  when Switch_On | High_Off =>
                     null;
               end case;
            when High =>
               case Event is
                  when Switch_Off =>
                     State := Off;
                     Lights.Set_Headlights_Off;
                     Lights.Set_High_Beams_Off;
                  when High_Off =>
                     State := On;
                     Lights.Set_High_Beams_Off;
                  when Switch_On | High_On =>
                     null;
               end case;
         end case;
      end Signal_Event;

      function Current_State return State_Type is
      begin
         return State;
      end Current_State;
   end Control;

   -- External Operations ---------------------------------
   procedure Signal_Event (Event : Event_Type) is
   begin
      Control.Signal_Event (Event);
   end Signal_Event;

   function Current_State return State_Type is
   begin
      return Control.Current_State;
   end Current_State;

end Headlights_V1;
