private package Induction_Motor.Operations is

-- The resources in a private child package are not accessible outside
-- the child hierarchy.  This ensures that non-induction motor
-- packages cannot access the low level routines for the motor.

   pragma Suppress (Elaboration_Check);

   subtype Degrees is Integer range 0 .. 200;
   Max : constant Degrees := 100;

   function Current_Temperature return Degrees;


   type Winding_State is (Off, On);

   procedure Set_Run_Windings (To : in Winding_State);

   procedure Set_Start_Windings (To : in Winding_State);

end Induction_Motor.Operations;
