with Ada.Text_IO;      use Ada.Text_IO;
with Induction_Motor;  use Induction_Motor;
procedure Induction_Motor_Demo is
begin
   Put_Line ("Starting tests");
   New_Line;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   New_Line;

   Put_Line ("Testing switch off when motor is in state Off");
   Put_Line ("Switching off motor");
   Switch_Off;
   delay 0.1;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   New_Line;

   Put_Line ("Testing switch on when motor is in state Off");
   Put_Line ("Switching on motor (start windings should turn on)");
   Switch_On;
   delay 0.1;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   New_Line;

   Put_Line ("Testing switch off when motor is in state Starting");
   delay 0.1;
   Put_Line ("Switching off motor (start windings should turn off)");
   Switch_Off;
   delay 0.1;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   New_Line;
   delay 1.0;

   Put_Line ("Testing motor transistion from Off to Starting to Running");
   Put_Line ("Switching on motor (start windings should turn on)");
   Switch_On;
   delay 0.1;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   Put_Line ("*** Wait for message about run windings powering ON then press Enter");
   Put_Line ("*** It will take about a minute for the motor to reach the Running state");
   Skip_Line;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   New_Line;

   Put_Line ("Checking for thermal cut off (state Running to state Off)");
   Put_Line ("*** Wait for message about run windings powering OFF then press Enter");
   Put_Line ("*** It will take about 10 seconds for the motor to over heat");
   Skip_Line;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   New_Line;
   delay 1.0;

   Put_Line ("Testing motor transistion from Running to Off after a switch off");
   Put_Line ("Switching on motor (start windings should turn on)");
   Switch_On;
   delay 0.5;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   Put_Line ("*** Wait for message about run windings powering ON then press Enter");
   Put_Line ("*** It will take about a minute for the motor to reach that state");
   Skip_Line;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));
   delay 1.0;
   Put_Line ("Switching off motor (start windings should turn off)");
   Switch_Off;
   delay 0.1;
   Put_Line ("Current motor state is " & State_Type'Image (Current_State));

   New_Line;
   Put_Line ("Tests complete");

end Induction_Motor_Demo;
   