with Ada.Text_IO; use Ada.Text_IO;
procedure Motor_Control is

   type Direction_Type is (Clockwise, Counter_Clockwise);
   type Winding_State  is (Off, On);


   procedure Set_Run_Windings (To : in Winding_State) is
   begin
      Put_Line ("Run windings " & Winding_State'Image (To));
   end Set_Run_Windings;

   procedure Set_Start_Windings (To : in Winding_State) is
   begin
      Put_Line ("Start windings " & Winding_State'Image (To));
   end Set_Start_Windings;

   procedure Set_Winding_Polarity (Direction : in Direction_Type) is
   begin
      Put_Line ("Winding polarity set to " &
                 Direction_Type'Image (Direction));
   end Set_Winding_Polarity;



   task Motor is
      entry Start;
      entry Stop;
      entry Set_Direction (Direction : in Direction_Type);
   end Motor;

   task body Motor is
      Running : Boolean := False;
   begin
      loop
         select
            accept Start;
            Set_Start_Windings (To => On);
            Running := True;
            delay 30.0;
            Set_Start_Windings (To => Off);
            Set_Run_Windings   (To => On);
         or
            accept Stop;
            Set_Run_Windings (To => Off);
            Running := False;
         or
            when not Running =>
            accept Set_Direction (Direction : Direction_Type) do
               Set_Winding_Polarity (Direction);
            end Set_Direction;
         end select;
      end loop;
   end Motor;

begin
   null;
end Motor_Control;

            