with Ada.Calendar;        use Ada.Calendar;
with Ada.Text_IO;         use Ada.Text_IO;
procedure Tea_Kettle is

   procedure Turn_On_Heat is
   begin
      Put_Line ("Turning on water heater");
   end Turn_On_Heat;

   procedure Turn_Off_Heat is
   begin
      Put_Line ("Turning off water heater");
   end Turn_Off_Heat;

   task Kettle is
      entry Turn_On;
      entry Turn_Off;
   end Kettle;

   task body Kettle is
      Year     : Ada.Calendar.Year_Number;
      Month    : Ada.Calendar.Month_Number;
      Day      : Ada.Calendar.Day_Number;
      Seconds  : Ada.Calendar.Day_Duration;
      On_Time  : Ada.Calendar.Time;
      Off_Time : Ada.Calendar.Time;
   begin
      -- Read the clock for current date/time
      On_Time := Ada.Calendar.Clock;
      -- Split the time value into Year, Month, Day, and Seconds
      Ada.Calendar.Split (On_Time, Year, Month, Day, Seconds);
      -- Set the turn on time to midnight (the start of today)
      On_Time := Ada.Calendar.Time_Of (Year, Month, Day, 0.0);
      -- Set the turn on time to 5:00 AM (5 hrs after midnight)
      On_Time := On_Time + Duration (5 * 60 * 60);
      -- Set the turn off time to 11:00 PM (18 hrs after on time)
      Off_Time := On_Time + Duration (18 * 60 * 60);
      loop
         select
            accept Turn_On;       -- manual turn on
            Turn_On_Heat;
         or
            accept Turn_Off;      -- manual turn off
            Turn_Off_Heat;
         or
            delay until On_Time;  -- automated turn on
            Turn_On_Heat;
            -- Turn on again in 24 hours
            On_Time := On_Time + Duration (24 * 60 * 60);
         or
            delay until Off_Time; -- automated turn off
            Turn_Off_Heat;
            -- Turn off again in 24 hours
            Off_Time := Off_Time + Duration (24 * 60 * 60);
         end select;
      end loop;
   end Kettle;

begin
   delay 5.0;
   Kettle .Turn_Off;
   delay 3.0;
   Kettle .Turn_On;
end Tea_Kettle;