with Ada.Text_IO;  use Ada.Text_IO;
package body Turnstiles is

   procedure Lock (ID : in Natural) is
   begin
      Put_Line ("   Locked turnstile" & Natural'Image (ID));
   end Lock;

   procedure Unlock (ID : in Natural) is
   begin
      Put_Line ("   Unlocked turnstile" & Natural'Image (ID));
   end Unlock;

   procedure Alarm (ID : in Natural) is
   begin
      Put_Line ("   Jumper turnstile" & Natural'Image (ID));
   end Alarm;


   protected body Turnstile_Control is

      procedure Signal_Event (Event : in Event_Type) is
      begin
         case State is
            when Locked =>
               case Event is
                  when Ticket =>
                     State := Unlocked;
                     Unlock (ID);
                  when Pass =>
                     Alarm (ID);
               end case;
            when Unlocked =>
               case Event is
                  when Ticket =>
                     null;
                  when Pass =>
                     State := Locked;
                     Lock (ID);
               end case;
         end case;
      end Signal_Event;

      function Current_State return State_Type is
      begin
         return State;
      end Current_State;

   end Turnstile_Control;

end Turnstiles;
