with Ada.Command_Line;
with Ada.Text_IO;
with CORBA.ORB;

with CORBAStudents.Student_Management;

with PolyORB.Setup.Client;
pragma Warnings (Off, PolyORB.Setup.Client);
--  Configure client with basic services

procedure Client is
   use Ada.Command_Line;
   use Ada.Text_IO;
   use CORBAStudents.Student_Management;
   use CORBAStudents;
   use CORBA;

   A_Student : CORBAStudents.Student_Management.Ref;

begin
   CORBA.ORB.Initialize ("ORB");
   if Argument_Count /= 1 then
      Put_Line ("usage : client <IOR_string_from_server>");
      return;
   end if;

   --  Getting the CORBA.Object

   CORBA.ORB.String_To_Object
     (CORBA.To_CORBA_String (Ada.Command_Line.Argument (1)),
                             A_Student);

   --  Checking if it worked

   if CORBAStudents.Student_Management.Is_Nil (A_Student) then
      Put_Line ("main : cannot invoke on a nil reference");
      return;
   end if;

   Register_To_Course
     (A_Student, To_CORBA_String ("John Doe"),
      To_CORBA_String ("xxx"), To_CORBA_String ("Ada"));
end Client;
