with Types; use Types;
package body RACWStudent is

   type Student_Record is record
      Term : Terminal_Access;
      Student : Student_Type;
   end record;

   Student_Table : array (1 .. 10) of Student_Record
     := (others => (null, "          "));

   procedure Register (MyTerminal : in Terminal_Access;
                       Student    : in Student_Type;
                       Password   : in Password_Type) is
   begin
      for J in Student_Table'Range loop
         if Student_Table (J).Term = null then
            Student_Table (J) := (MyTerminal, Student);
            return;
         end if;
      end loop;

      raise Constraint_Error;
      --  If we reach this point, it means that there is
      --  no free slot in the table
   end Register;

   function Find_Terminal (Student : in Student_Type)
                          return Terminal_Access is
   begin
      for J in Student_Table'Range loop
         if Student_Table (J).Student = Student then
            return Student_Table (J).Term;
         end if;
      end loop;

      return null;
   end Find_Terminal;

   function Compute_Score  (Student  : in Student_Type;
                            Password : in Password_Type)
                            return Integer is
      Score : Integer := 0;
      Term  : Terminal_Access := Find_Terminal (Student);
      --  Find Student terminal

   begin
      --  Compute score
      --  Score := ...

      if Term /= null then
         --  Notify on student terminal
         Notify (Term, Student, Score);
      end if;

      return Score;
   end Compute_Score;

end RACWStudent;
