with Ada.Text_IO;  use Ada.Text_IO;

with CORBA.Impl;
with CORBA.Object;
with CORBA.ORB;

with PortableServer.POA.Helper;
with PortableServer.POAManager;

with CORBAStudents.Student_Management.Impl;

with PolyORB.Setup.No_Tasking_Server;
pragma Warnings (Off, PolyORB.Setup.No_Tasking_Server);
--  Configure server with basic services, without tasking

procedure Server is

   procedure Configure_Servants is
      Root_POA : PortableServer.POA.Local_Ref;
      Ref : CORBA.Object.Ref;
      Obj : constant CORBA.Impl.Object_Ptr
        := new CORBAStudents.Student_Management.Impl.Object;

   begin
      --  Retrieve Root POA
      Root_POA := PortableServer.POA.Helper.To_Local_Ref
        (CORBA.ORB.Resolve_Initial_References
           (CORBA.ORB.To_CORBA_String ("RootPOA")));

      PortableServer.POAManager.Activate
        (PortableServer.POA.Get_The_POAManager (Root_POA));

      --  Set up new object
      Ref := PortableServer.POA.Servant_To_Reference
        (Root_POA, PortableServer.Servant (Obj));

      --  Output IOR
      Put_Line (CORBA.To_Standard_String
                 (CORBA.Object.Object_To_String (Ref)));

   end Configure_Servants;

begin
   --  Perform CORBA configuration and initialisation
   CORBA.ORB.Init (CORBA.ORB.To_CORBA_String ("ORB"),
                   CORBA.ORB.Command_Line_Arguments);

   --  Configure application-specific servant
   Configure_Servants;

   --  Launch the server
   CORBA.ORB.Run;
end Server;
