package SharedObjects is
   pragma Shared_Passive;

   Max_Student : constant Integer := 42;

   type Score_Array is array (1 .. Max_Student) of Integer;

   Unprotected_Scores : Score_Array;
   --  The user needs to provide protection
   --  against concurrent access

   protected Protected_Scores is
      procedure Set (Index : in  Integer;
                     Score : in  Integer);
      procedure Get (Index : in  Integer;
                     Score : out Integer);
   private
      The_Scores : Score_Array;
   end Protected_Scores;

end SharedObjects;
