with Types; use Types;
package Terminal is
   pragma Pure;

   type Terminal_Type is abstract tagged limited private;
   --  Terminal_Type is an abstract tagged type, meaning it
   --  is an interface that will be later implemented by other
   --  types that specialize it.

   procedure Notify (MyTerm  : access Terminal_Type;
                     Student : in Student_Type;
                     Score   : in Integer) is abstract;
   --  Notify is an abstract procedure attached to the
   --  Terminal_Type. Each specialization of Terminal_Type
   --  shall either be abstract itself, or provide an
   --  implementation of this procedure

private
   type Terminal_Type is abstract tagged limited null record;
end Terminal;
