with Ada.Real_Time; use Ada.Real_Time;
with Text_IO;       use Text_IO;
procedure A_Periodic_Task_Demo is

   -- The following procedure contains a "job" that
   -- we want to execute periodically
   procedure Run_Job_Of_The_Task is
   begin
      Put_Line("Periodic task is released and executes its job");
   end Run_Job_Of_The_Task;


   task A_Periodic_Task; -- Define a task

   -- The body of our periodic task
   task body A_Periodic_Task is
      Next_Time : Ada.Real_Time.Time := Clock;
      Period    : constant Time_Span := Milliseconds (250);
   begin
      loop
         -- The task is released : it runs its job
         Run_Job_Of_The_Task;

         -- Determine the next release time
         Next_Time := Next_Time + Period;

         -- Wait for the next release time
         delay until Next_Time;
      end loop;
   end A_Periodic_Task;

begin
   null;
end A_Periodic_Task_Demo;

