with Generic_Periodic_Task;
with Text_IO; use Text_IO;
procedure Car_System is

   -- The following three parameterless procedures are stubs for
   -- the actual code that runs in the car

   procedure Display_Speed is
   begin
      Put_Line ("Tdisplay displays the speed of the car");
   end Display_Speed;

   procedure Read_Speed is
   begin
      Put_Line ("Tspeed reads speed sensor");
   end Read_Speed;

   procedure Monitor_Engine is
   begin
      Put_Line ("Tengine performs engine monitoring algorithm");
   end Monitor_Engine;


   -- Instantiate a periodic task package from the generic package
   -- for each of our three run procedures

   package P1 is new Generic_Periodic_Task (Run => Display_Speed);
   package P2 is new Generic_Periodic_Task (Run => Read_Speed);
   package P3 is new Generic_Periodic_Task (Run => Monitor_Engine);

   -- Our three tasks
   Tdisplay : P1.Periodic_Task (Task_Priority => 12,
                                Period_In_Milliseconds => 100);
								
   Tspeed   : P2.Periodic_Task (Task_Priority => 11,
                                Period_In_Milliseconds => 250);
								
   Tengine  : P3.Periodic_Task (Task_Priority => 10,
                                Period_In_Milliseconds => 500);

   pragma Priority (20);  -- Priority of main subprogram

begin
   Put_Line ("Tasks will start after the main subprogram completes!");
end Car_System;
   